//depends on renderer.js being available
//and guiconfig.js
//
//requires:
//drawrect(x,y,w,h,color,blend)
//drawtext(x,y,text,color,font,centre)
//getcolor(r,g,b)
var gui_docorners = true;
var gui_textoverlay = -1;

function drawbox(sx,sy,fx,fy,title)
{
	if(!title)
	{
		title = "";
	}
	var tx = 0;
	var ty = 0;
	var tw = 0;
	var th = 0;
	var tt = 4;
	//drawrect(sx-8,sy-8,fx-sx+16,fy-sy+16,'#000000',0.05);
	//drawrect(sx-4,sy-4,fx-sx+8,fy-sy+8,'#000000',0.05);
	for(var i=tt;i>0;i--)
	{
		drawrect(sx-i*2,sy-i*2,fx-sx+i*4,fy-sy+i*4,'#000000',0.05);
	}
	if(title.length>0)
	{
		tw = title.length * 12;
		th = 30;
		tx = ((sx + fx - tw ) / 2)
		ty = sy;
		//drawrect(tx-4,ty-th/2-4,tw+8,th/2+4,'#000000',0.5);
		//drawrect(tx-2,ty-th/2-2,tw+4,th/2+2,'#000000',0.25);
		for(var i=tt;i>0;i--)
		{
			drawrect(tx-i*2,ty-th/2-i*2,tw+i*4,th/2+i*4,'#000000',0.05);
		}
	}
	drawrect(sx-1,sy-1,fx-sx+2,fy-sy+2,getcolor(themebox1[0],themebox1[1],themebox1[2]),0);
	drawrect(sx,sy,fx-sx,fy-sy,getcolor(themebox2[0],themebox2[1],themebox2[2]),0);
	drawrect(sx+1,sy+1,fx-sx-2,fy-sy-2,getcolor(themebox3[0],themebox3[1],themebox3[2]),0);
	//
	drawunfilledrect(sx-1+5,sy-1+5,fx-sx+2-10,fy-sy+2-10,getcolor(themebox1[0],themebox1[1],themebox1[2]),0);
	drawunfilledrect(sx+5,sy+5,fx-sx-10,fy-sy-10,getcolor(themebox2[0],themebox2[1],themebox2[2]),0);
	drawunfilledrect(sx+1+5,sy+1+5,fx-sx-2-10,fy-sy-2-10,getcolor(themebox3[0],themebox3[1],themebox3[2]),0);
	//
	if(title.length>0)
	{
		drawrect(tx-1,ty-1-th/2,tw+2,th+3,getcolor(themebox1[0],themebox1[1],themebox1[2]),0);
		drawrect(tx,ty-th/2,tw,th+1,getcolor(themebox2[0],themebox2[1],themebox2[2]),0);
		drawgradient(tx+1,ty+2-th/2,tx+tw-2,1+ty+th/2-2,0.99,themetitle3,themetitle4)
		drawtext((sx+fx)/2,ty+4,title,themetext,themefontsize+' '+themefont,true);
	}
}

function drawdatalabel(sx,sy,fx,fy,title)
{
	//drawrect(sx-1,sy-1,fx-sx+2,fy-sy+2,getcolor(themebox1[0],themebox1[1],themebox1[2]),0);
	drawrect(sx-1,sy-1,fx-sx+2,fy-sy+2,getcolor(parseInt((themebox2[0]+themebox1[0])/2),parseInt((themebox2[1]+themebox1[1])/2),parseInt((themebox2[2]+themebox1[2])/2)),0);
	drawrect(sx+1,sy+1,fx-sx-2,fy-sy-2,getcolor(parseInt(themebox3[0]*0.85),parseInt(themebox3[1]*0.85),parseInt(themebox3[2]*0.85)),0);
	//
	drawrect(sx+1,sy+1,fx-sx-3,2,getcolor(parseInt(themebox2[0]*0.15),parseInt(themebox2[1]*0.15),parseInt(themebox2[2]*0.15)),0);
	drawrect(sx+1,sy+1,2,fy-sy-2,getcolor(parseInt(themebox2[0]*0.15),parseInt(themebox2[1]*0.15),parseInt(themebox2[2]*0.15)),0);
	drawrect(sx+1,fy-3,fx-sx-3,2,getcolor(parseInt(themebox2[0]*1.15),parseInt(themebox2[1]*1.15),parseInt(themebox2[2]*1.15)),0);
	drawrect(fx-3,sy+1,2,fy-sy-2,getcolor(parseInt(themebox2[0]*1.15),parseInt(themebox2[1]*1.15),parseInt(themebox2[2]*1.15)),0);
	if(!title)
	{
		return false;
	}
	if(title.length<=0)
	{
		return false;
	}
	drawtext(sx+2,(sy+fy)/2+4,title,themetext,themefontsize+' '+themefont,false);
	if(mouse.x>=sx && mouse.x<=fx && mouse.y>=sy && mouse.y<=fy)
	{
		return true;
	}
}

function drawbuttongrad(sx,sy,fx,fy,title,c1,c2)
{
	var lrvalue = false;
	if(!title)
	{
		return;
	}
	if(title.length<=0)
	{
		return;
	}
	var hover = false;
	var tt = 4;
	if(mouse.x>sx && mouse.y>sy && mouse.x<fx && mouse.y<fy)
	{
		hover = true;
		if(mouse.clicked!=mouse.oclicked && mouse.clicked==false)
		{
			mouse.oclicked=false;
			lrvalue = true;
			//playsound(CAT_AUDIO_CLICK);
		}
	}
	var gsx = 1.0;
	if(title.length<2)
	{
		//gsx = 0.5;
	}
	if(hover)
	{
		//drawimage(images[CAT_BUTTON0].img,(sx+fx)/2,(sy+fy)/2,0,gsx,1,0,0,0,1);
		//drawimage(images[CAT_BUTTON0].img,(sx+fx)/2,(sy+fy)/2,0,gsx,1,0,1,0,0.25);
	}
	else
	{
		//drawimage(images[CAT_BUTTON0].img,(sx+fx)/2,(sy+fy)/2,0,gsx,1,0,0,0,1);
	}
	//if(gui_textoverlay!=-1 && false)
	//{
	//	drawanimimage(images[CAT_TEXTOVERLAY].img,(sx+fx)/2,(sy+fy)/2,0,1,1,gui_textoverlay,0,0,1,CAT_TEXTOVERLAY);
	//	gui_textoverlay = -1;
	//}
	//else
	//{
	//	drawtext((sx+fx)/2,4+(sy+fy)/2+2,title,themetext,themefontsize+' '+themefont,true);
	//}
	//return lrvalue;
	if(hover)
	{
		//drawrect(sx-4,sy-4,fx-sx+8,fy-sy+8,'#111111',0.5);
		//drawrect(sx-2,sy-2,fx-sx+4,fy-sy+4,'#111111',0.25);
		for(var i=tt;i>0;i--)
		{
			drawrect(sx-i*2,sy-i*2,fx-sx+i*4,fy-sy+i*4,'#111111',0.05);
		}
		drawrect(sx-1,sy-1,fx-sx+2,fy-sy+2,getcolor(parseInt(themebox1[0]*1.25),parseInt(themebox1[1]*1.25),parseInt(themebox1[2]*1.25)),0);
		drawrect(sx,sy,fx-sx,fy-sy,getcolor(parseInt(themebox2[0]*1.25),parseInt(themebox2[1]*1.25),parseInt(themebox2[2]*1.25)),0);
		//drawgradient(sx+1,sy+1,fx-1,fy-1,0.99,themetitle1,themetitle2)
		var t1 = [c1[0]*1.25,c1[1]*1.25,c1[2]*1.25];
		var t2 = [c2[0]*1.25,c2[1]*1.25,c2[2]*1.25];
		drawgradient(sx+1,sy+1,fx-1,fy-1,0.99,t1,t2)
		drawtext((sx+fx)/2,4+(sy+fy)/2+2,title,themetext,themefontsize+' '+themefont,true);
	}
	else
	{
		//drawrect(sx-4,sy-4,fx-sx+8,fy-sy+8,'#000000',0.5);
		//drawrect(sx-2,sy-2,fx-sx+4,fy-sy+4,'#000000',0.25);
		for(var i=tt;i>0;i--)
		{
			drawrect(sx-i*2,sy-i*2,fx-sx+i*4,fy-sy+i*4,'#000000',0.05);
		}
		drawrect(sx-1,sy-1,fx-sx+2,fy-sy+2,getcolor(themebox1[0],themebox1[1],themebox1[2]),0);
		drawrect(sx,sy,fx-sx,fy-sy,getcolor(themebox2[0],themebox2[1],themebox2[2]),0);
		drawgradient(sx+1,sy+1,fx-1,fy-1,0.99,c1,c2);
		drawtext((sx+fx)/2,4+(sy+fy)/2+2,title,themetext,themefontsize+' '+themefont,true);
	}
	return lrvalue;
}

function drawbutton(sx,sy,fx,fy,title)
{
	var lrvalue = false;
	if(!title)
	{
		return;
	}
	if(title.length<=0)
	{
		return;
	}
	var hover = false;
	var tt = 4;
	if(mouse.x>sx && mouse.y>sy && mouse.x<fx && mouse.y<fy)
	{
		hover = true;
		if(mouse.clicked!=mouse.oclicked && mouse.clicked==false)
		{
			mouse.oclicked=false;
			//playsound(CAT_AUDIO_CLICK);
			lrvalue = true;
		}
	}
	var gsx = 1.0;
	if(title.length<2)
	{
	//	gsx = 0.5;
	}
	if(hover)
	{
		//drawimage(images[CAT_BUTTON0].img,(sx+fx)/2,(sy+fy)/2,0,gsx,1,0,0,0,1);
		//drawimage(images[CAT_BUTTON0].img,(sx+fx)/2,(sy+fy)/2,0,gsx,1,0,1,0,0.25);
	}
	else
	{
		//drawimage(images[CAT_BUTTON0].img,(sx+fx)/2,(sy+fy)/2,0,gsx,1,0,0,0,1);
	}
	//if(gui_textoverlay!=-1 && false)
	//{
	//	drawanimimage(images[CAT_TEXTOVERLAY].img,(sx+fx)/2,(sy+fy)/2,0,1,1,gui_textoverlay,0,0,1,CAT_TEXTOVERLAY);
	//	gui_textoverlay = -1;
	//}
	//else
	//{
	//	drawtext((sx+fx)/2,4+(sy+fy)/2+2,title,themetext,themefontsize+' '+themefont,true);
	//}
	//drawtext((sx+fx)/2,4+(sy+fy)/2+2,title,themetext,'20px Times New Roman',true);
	//return lrvalue;
	if(hover)
	{
		//drawrect(sx-4,sy-4,fx-sx+8,fy-sy+8,'#111111',0.5);
		//drawrect(sx-2,sy-2,fx-sx+4,fy-sy+4,'#111111',0.25);
		for(var i=tt;i>0;i--)
		{
			drawrect(sx-i*2,sy-i*2,fx-sx+i*4,fy-sy+i*4,'#111111',0.05);
		}
		drawrect(sx-1,sy-1,fx-sx+2,fy-sy+2,getcolor(parseInt(themebox1[0]*1.25),parseInt(themebox1[1]*1.25),parseInt(themebox1[2]*1.25)),0);
		drawrect(sx,sy,fx-sx,fy-sy,getcolor(parseInt(themebox2[0]*1.25),parseInt(themebox2[1]*1.25),parseInt(themebox2[2]*1.25)),0);
		//drawgradient(sx+1,sy+1,fx-1,fy-1,0.99,themetitle1,themetitle2)
		var t1 = [themetitle1[0]*1.25,themetitle1[1]*1.25,themetitle1[2]*1.25];
		var t2 = [themetitle2[0]*1.25,themetitle2[1]*1.25,themetitle2[2]*1.25];
		drawgradient(sx+1,sy+1,fx-1,fy-1,0.99,t1,t2)
		drawtext((sx+fx)/2,4+(sy+fy)/2+2,title,themetext,themefontsize+' '+themefont,true);
	}
	else
	{
		//drawrect(sx-4,sy-4,fx-sx+8,fy-sy+8,'#000000',0.5);
		//drawrect(sx-2,sy-2,fx-sx+4,fy-sy+4,'#000000',0.25);
		for(var i=tt;i>0;i--)
		{
			drawrect(sx-i*2,sy-i*2,fx-sx+i*4,fy-sy+i*4,'#000000',0.05);
		}
		drawrect(sx-1,sy-1,fx-sx+2,fy-sy+2,getcolor(themebox1[0],themebox1[1],themebox1[2]),0);
		drawrect(sx,sy,fx-sx,fy-sy,getcolor(themebox2[0],themebox2[1],themebox2[2]),0);
		drawgradient(sx+1,sy+1,fx-1,fy-1,0.99,themetitle1,themetitle2);
		drawtext((sx+fx)/2,4+(sy+fy)/2+2,title,themetext,themefontsize+' '+themefont,true);
	}
	return lrvalue;
}

function drawgradient(sx,sy,fx,fy,my,clr1,clr2)
{
	//clr1 = array r,g,b
	//clr2 = array r,g,b
	//my = float 0 to 1
	var hy = parseInt(sy + (fy - sy) * my);
	for(var y=sy;y<hy;y++)
	{
		var r1 = clr1[0];
		var g1 = clr1[1];
		var b1 = clr1[2];
		var r2 = clr2[0];
		var g2 = clr2[1];
		var b2 = clr2[2];
		var r = parseInt(r1 + (r2-r1)*(y - sy) / (hy - sy));
		var g = parseInt(g1 + (g2-g1)*(y - sy) / (hy - sy));
		var b = parseInt(b1 + (b2-b1)*(y - sy) / (hy - sy));
		if(r<0)
		{
			r = 0;
		}
		if(g<0)
		{
			g = 0;
		}
		if(b<0)
		{
			b = 0;
		}
		if(r>255)
		{
			r = 255;
		}
		if(g>255)
		{
			g = 255;
		}
		if(b>255)
		{
			b = 255;
		}
		drawrect(sx,y,fx-sx,1,getcolor(r,g,b),0);
		//drawrect(x,y,w,h,color,blend)
	}
	for(var y=hy;y<fy;y++)
	{
		var r2 = clr1[0];
		var g2 = clr1[1];
		var b2 = clr1[2];
		var r1 = clr2[0];
		var g1 = clr2[1];
		var b1 = clr2[2];
		var r = parseInt(r1 + (r2-r1)*(y - hy) / (fy - hy));
		var g = parseInt(g1 + (g2-g1)*(y - hy) / (fy - hy));
		var b = parseInt(b1 + (b2-b1)*(y - hy) / (fy - hy));
		if(r<0)
		{
			r = 0;
		}
		if(g<0)
		{
			g = 0;
		}
		if(b<0)
		{
			b = 0;
		}
		if(r>255)
		{
			r = 255;
		}
		if(g>255)
		{
			g = 255;
		}
		if(b>255)
		{
			b = 255;
		}
		drawrect(sx,y,fx-sx,1,getcolor(r,g,b),0);
	}
}
