///////////////////////
//init.js
//
//Handles loading all images and sounds
//as well as setting up the window and 
//input devices as well as handling differences
// related to IE browser
//and other such.
//CONSTANTS
var VERSIONINT = 103;
var AUTHOR = 'Matt Lloyd';
var YEAR = '2023';
var SW = 1600;
var SH = 900;
var FULLSCREEN = false; //change this and the above SW/SH will be used as screen resolution....
//YOU SHOULD NOT NEED TO TOUCH ANYTHING BELOW HERE....
var VERSIONNUMBER = 1.03;
var VERSIONSTR = '20231030';
var UID = 0;
var tmpUID = localStorage.getItem('JGEUID');
if(typeof(tmpUID)==='undefined')
{
	var Date = new Date();
	UID = Date.now();
	localStorage.setItem("JGEUID",""+UID);
}
else
{
	if(tmpUID === null)
	{
		var date = new Date();
		UID = Date.now();
		localStorage.setItem("JGEUID",""+UID);
	}
	else
	{
		UID = tmpUID;
	}
}
//screen resolution (window resolution)
var isIE = detectIE();
if(isIE===false)
{
	//do nothing
}
else
{
	isIE = true;
}
//canvas offset (for mobile)
var SOFFX = 0;
var SOFFY = 0;
//seed for random number generator
var seed = 2234567;
var tooslow = false;
var tooslowcount = 0;
//loadprogress
var loadprogress = 0; //how many images currently loaded
var loadstate = 0; //when 100 it means all loaded
//var loadmax = 1;//;put this in when you know it for sure - 1 more than the highest index element.
//
//same as for above but for audio not images
var audioloadprogress = 0;
var audioloadstate = 0;
var audioon = true;//false;
var AUDIOBLOCK = false;
var MUSICVOLUME = 0.1;
var FXVOLUME = 0.1;
//
//delta timing (not used)
var deltatime = 0;
//canvas
var viewportWidth = window.innerWidth;
var viewportHeight = window.innerHeight;
//fullscreen....
if(FULLSCREEN)
{
	SW = viewportWidth;
	SH = viewportHeight;
}
setglobalscales(viewportWidth,viewportHeight);
var canvas = document.getElementById("canvas");
var canvascontext = canvas.getContext("2d");
var canvasWidth = SW*RENDER_GLOBALSX;
var canvasHeight = SH*RENDER_GLOBALSY;
resetcanvas();//canvas.style.cursor = "none";
//background image behind canvas
//audiodiv.style.display = "none";
//backbuffer - second buffer
//a second buffer is used to draw to to ensure smooth drawing
//so we can flip all the drawing into view at one time rather than pop things
//on the screen in sequence.
var canvasbuffer = document.createElement("canvas");
var canvasbuffercontext = canvasbuffer.getContext("2d");
resetcanvasbuffer();
//input devices
var touched=false;
var touchinterface=false;
var touchobj = new Object();
var touchmode = 0;//14oct2022
var TOUCHDOWN = 1;//14oct2022
var TOUCHUP = 2;//14oct2022
var mouse = new Object();
mouse.x=0;
mouse.y=0;
mouse.oclicked=false;
mouse.clicked=false;
mouse.rclick=false;
mouse.orclick=false;
mouse.lclick=false;//25mar2022
mouse.olclick=false;//25mar2022

mouse.firstclicked=false;
var keysDown = {};
var keycodepressed = -1;
var escapepressed = false;
var zeropressed = false;
var audios = new Array();
var images = new Array(); //array to store our images in
loadall(); //put your resource loading in here.....
var musicframe = 120;
//listeners for keys and mousepresses
//removed key presses - totally mouse driven now

addEventListener("keydown", function (e) 
{
keysDown[e.keyCode] = true;
//if((e.keyCode>=32 && e.keyCode<=40) || e.keyCode==65 || e.keyCode==68 || e.keyCode==83 || e.keyCode==87)
//{
//window.focus();   
//e.preventDefault();  
//e.stopPropagation();  
//}
}, false);

addEventListener("keyup", function (e) 
{
//
if(e.keyCode==27)
{
	escapepressed = true;
}
if(e.keyCode==48)
{
	zeropressed = true;
}
delete keysDown[e.keyCode];
//if((e.keyCode>=32 && e.keyCode<=40) || e.keyCode==65 || e.keyCode==68 || e.keyCode==83 || e.keyCode==87)
//{
//window.focus();   
//e.preventDefault();  
//e.stopPropagation();  
//}
}, false);

addEventListener("keypress", function (e)
{
keycodepressed=e.keyCode;
}, false);

canvas.addEventListener("touchstart",function(e)
{
	touchobj = e.changedTouches[0];
	if(!gr_PLAYING)
	{
	mouse.x = parseInt(touchobj.clientX) - SOFFX;
	mouse.y = parseInt(touchobj.clientY) - SOFFY;
	if(e.button==0)
	{
		mouse.oclicked = false;
		mouse.clicked=true;
	}
	if(e.button==2)
	{
		mouse.rclick=true;
	}
	mouse.firstclicked=true;
	scalemouse();
	}
	touched=true;
	touchinterface=true;
	mobileaudioenabled=true;	
	e.preventDefault();
	mouse.lclick = mouse.clicked;
	mouse.olclick = mouse.oclicked;
	touchmode = 1; //touchdown//14oct2022
})

canvas.addEventListener("touchmove",function(e)
{
	touchobj = e.changedTouches[0];
	if(!gr_PLAYING)
	{
	mouse.x = parseInt(touchobj.clientX) - SOFFX;
	mouse.y = parseInt(touchobj.clientY) - SOFFY;
	if(e.button==0)
	{
		mouse.oclicked = true;
		mouse.clicked=true;
	}
	if(e.button==2)
	{
		mouse.rclick=true;
	}
	mouse.firstclicked=true;
	scalemouse();
	}
	touched=true;
	touchinterface=true;	
	mobileaudioenabled=true;
	e.preventDefault();
	mouse.lclick = mouse.clicked;
	mouse.olclick = mouse.oclicked;
	touchmode = 1; // touchdown//14oct2022
})

canvas.addEventListener("touchend",function(e)
{
	if(!gr_PLAYING)
	{
	if(e.button==0)
	{
		mouse.oclicked = true;
		mouse.clicked=false;
	}
	if(e.button==2)
	{
		mouse.rclick=false;
	}
	
	}
	touched=false;
	touchinterface=true;
mobileaudioenabled=true;	
	e.preventDefault();
	mouse.lclick = mouse.clicked;
	mouse.olclick = mouse.oclicked;
	touchmode = 2;//touchup//14oct2022
})

canvas.addEventListener("contextmenu", function(e)
{
	mouse.rclick=true;
	e.preventDefault();
	return false;
})


function getmousecoords(event)
{
	if(!gr_PLAYING)
	{
	mouse.x = event.layerX - SOFFX;
	mouse.y = event.layerY - SOFFY;
	scalemouse();
	}
	return false;
}

function getPosition(event)
{
	var e = event;
	if(!gr_PLAYING)
	{
	mouse.oclicked=mouse.clicked;
	if(e.button==0)
	{
		mouse.clicked=true;
	}
	if(e.button==2)
	{
		mouse.rclick=true;
	}
	
	mouse.firstclicked=true;
	mobileaudioenabled=true;
	if(event.layerX && event.layerY)
	{
		mouse.x = event.layerX - SOFFX;
		mouse.y = event.layerY - SOFFY;
	}
	else
	{
		mouse.x = event.clientX - SOFFX;
		mouse.y = event.clientY - SOFFY;
	}
	scalemouse();
	mouse.lclick = mouse.clicked;
	mouse.olclick = mouse.oclicked;
	}
	return false;
}

function mouseup(event)
{
	if(!gr_PLAYING)
	{
		if(typeof(event)!=='undefined')
		{
			if(event.button==0)
			{
				mouse.oclicked=true;
				mouse.clicked=false;
			}
			if(event.button==2)
			{
				mouse.rclick=false;
			}
		}
	}
	mouse.lclick = mouse.clicked;
	mouse.olclick = mouse.oclicked;
	return false;
}

function updateloadscreen(i)
{
	//
	loadprogress++;
	loadstate = 100 * loadprogress / loadmax;
	if(loadprogress>=loadmax)
	{
		loadstate = 100;
	}
	images[i].img.dataset.loaded = true;
}

function updateaudioprogress()
{
	//
	audioloadprogress++;
	audioloadstate = 100 * audioloadprogress / audioloadmax;
	if(audioloadprogress>=audioloadmax)
	{
		audioloadstate = 100;
	}
}
/**
 * detect IE
 * returns version of IE or false, if browser is not Internet Explorer
 */

function detectIE() {
  var ua = window.navigator.userAgent;
  // Test values; Uncomment to check result …
  // IE 10
  // ua = 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; Trident/6.0)';
  // IE 11
  // ua = 'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko';
  // Edge 12 (Spartan)
  // ua = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.71 Safari/537.36 Edge/12.0';
  // Edge 13
  // ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2486.0 Safari/537.36 Edge/13.10586';
  var msie = ua.indexOf('MSIE ');
  if (msie > 0) {
    // IE 10 or older => return version number
    return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
  }
  var trident = ua.indexOf('Trident/');
  if (trident > 0) {
    // IE 11 => return version number
    var rv = ua.indexOf('rv:');
    return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
  }
  var edge = ua.indexOf('Edge/');
  if (edge > 0) {
    // Edge (IE 12+) => return version number
    return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
  }
  // other browser
  return false;
}

//////////////////////////////
//public facing functions
function loadmusic(file)
{
	var i = audios.length;
	loadmusic(i,file);
	return i;
}

function loadaudio(file)
{
	var i = audios.length;
	loadaudio(i,file);
	return i;
}

function loadimage(file)
{
	var i = images.length;
	loadimage(i,file);
	return i;
}

function loadanimimage(file,cwidth,cheight,nwide,nhigh)
{
	var i = images.length;
	loadanimimage(i,file,cwidth,cheight,nwide,nhigh);
	return i;
}
//////////////////////////

function loadmusic(i,file)
{
	//audioloadmax++;
	audios[i] = new Object();
	audios[i].music = true;
	audios[i].snd = new Audio();
	audios[i].snd.src = file + "?v="+VERSIONINT;
	audios[i].snd.load();

	audios[i].snd.addEventListener("canplay",function(e){
		updateaudioprogress();
	},false);
}

function loadaudio(i,file)
{
	//audioloadmax++;
	audios[i] = new Object();
	audios[i].music = false;
	audios[i].snd = new Audio();
	audios[i].snd.src = file + "?v="+VERSIONINT;
	audios[i].snd.load();

	audios[i].snd.addEventListener("canplay",function(e){
		updateaudioprogress();
	},false);
}


function loadimage(i,file)
{
	//loadmax++;
	images[i] = new Object();
	images[i].cat = 0; //cat is currently not used...ignore this
	images[i].img = new Image();
	images[i].img.dataset.loaded = false;
	images[i].img.src = file + "?v="+VERSIONINT;
	images[i].img.dataset.anim = '-1';
	images[i].img.dataset.file = file;
	images[i].img.onload = function(){updateloadscreen(i)}; //function to call on completing load of each image
	images[i].anim = false;
}

function loadanimimage(i,file,cellwidth,cellheight,cellswide,cellshigh)
{
	//loadmax++;
	images[i] = new Object();
	images[i].cat = 0; //cat is currently not used...ignore this
	images[i].img = new Image();
	images[i].img.dataset.loaded = false;
	images[i].img.src = file + "?v="+VERSIONINT;
	images[i].img.dataset.anim = i;
	images[i].img.dataset.file = file;
	images[i].img.onload = function(){updateloadscreen(i)}; //function to call on completing load of each image
	images[i].anim = true;
	images[i].cwx = cellwidth;
	images[i].chy = cellheight;
	images[i].cwn = cellswide;
	images[i].chn = cellshigh;
}
var RENDER_GLOBALSX = 1.0;
var RENDER_GLOBALSY = 1.0;

function setglobalscales(w,h)
{
	//do not touch
	RENDER_GLOBALSX = 1.0;
	RENDER_GLOBALSY = 1.0;
	//SW = 800
	//SH = 600
	//we are basing on the width, not the height....
	if(w!=0)
	{
		RENDER_GLOBALSX = w / SW;
		RENDER_GLOBALSY = w / SW;
		if(SH*RENDER_GLOBALSY>h)
		{
			RENDER_GLOBALSX = h / SH;
			RENDER_GLOBALSY = h / SH;
		}
	}
}

function scalemouse()
{
	mouse.x /= RENDER_GLOBALSX;
	mouse.y /= RENDER_GLOBALSY;
}

function reversemousescale()
{
	mouse.x *= RENDER_GLOBALSX;
	mouse.y *= RENDER_GLOBALSY;
}

function resetcanvas()
{
	viewportWidth = window.innerWidth;
	viewportHeight = window.innerHeight;
	setglobalscales(viewportWidth,viewportHeight);
	canvas = document.getElementById("canvas");
	canvascontext = canvas.getContext("2d");
	canvasWidth = SW*RENDER_GLOBALSX;
	canvasHeight = SH*RENDER_GLOBALSY;
	canvas.style.position = "absolute";
	canvas.setAttribute("width", canvasWidth);
	canvas.setAttribute("height", canvasHeight);
	canvas.style.left = (viewportWidth/2 - canvasWidth/2 ) + "px";
	canvas.style.top = 0 + "px";
	canvas.style.width = canvasWidth+"px";
	canvas.style.height = canvasHeight+"px";
}

function resetcanvasbuffer()
{
	canvasbuffer.width = canvas.width;
	canvasbuffer.height = canvas.height;
	canvasbuffercontext = canvasbuffer.getContext("2d");
}

function mousex()
{
	return mouse.x;
}

function mousey()
{
	return mouse.y;
}

function rightclicked()
{
	if(mouse.rclick)
	{
		return true;
	}
	return false;
}

function leftclicked()
{
	if(mouse.clicked!=mouse.oclicked && mouse.clicked==false)
	{
		mobileaudioenabled=true;
		return true;
	}
	return false;
}

function leftdown()
{
	if(mouse.clicked)
	{
		mobileaudioenabled=true;
		return true;
	}
	return false;
}

function leftup()
{
	if(!mouse.clicked)
	{
		return true;
	}
	return false;
}